## ros-lunar-ros-control-boilerplate 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ros_control_boilerplate)

# C++ 11
set(CMAKE_CXX_FLAGS "-std=c++11 -Wall ${CMAKE_CXX_FLAGS}")

find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  hardware_interface
  controller_manager
  roscpp
  control_msgs
  trajectory_msgs
  actionlib
  urdf
  joint_limits_interface
  transmission_interface
  control_toolbox
  std_msgs
  sensor_msgs
  rosparam_shortcuts
)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
find_package(Gflags REQUIRED)
find_package(Eigen3 REQUIRED)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    hardware_interface
    controller_manager
    roscpp
    control_msgs
    trajectory_msgs
    urdf
    joint_limits_interface
    transmission_interface
    control_toolbox
    std_msgs
    sensor_msgs
    rosparam_shortcuts
  LIBRARIES
    generic_hw_control_loop
    generic_hw_interface
    sim_hw_interface
)

###########
## Build ##
###########

include_directories(SYSTEM ${EIGEN3_INCLUDE_DIRS})

include_directories(
  include/
  ${catkin_INCLUDE_DIRS}
  ${Gflags_INCLUDE_DIRS}
)

# Control loop
add_library(generic_hw_control_loop src/generic_hw_control_loop.cpp)
target_link_libraries(generic_hw_control_loop
  ${catkin_LIBRARIES}
)

# Generic Hardware Interface
add_library(generic_hw_interface
  src/generic_hw_interface.cpp
)
target_link_libraries(generic_hw_interface
  ${catkin_LIBRARIES}
)

# Simulation Hardware Interface
add_library(sim_hw_interface
  src/sim_hw_interface.cpp
)
target_link_libraries(sim_hw_interface
  generic_hw_interface
  ${catkin_LIBRARIES}
)

# Main control executable
add_executable(${PROJECT_NAME}_sim_hw_main src/sim_hw_main.cpp)
set_target_properties(${PROJECT_NAME}_sim_hw_main PROPERTIES OUTPUT_NAME sim_hw_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_sim_hw_main
  sim_hw_interface
  generic_hw_control_loop
  ${catkin_LIBRARIES}
)

# Test trajectory generator node
add_executable(${PROJECT_NAME}_test_trajectory src/tools/test_trajectory.cpp)
set_target_properties(${PROJECT_NAME}_test_trajectory PROPERTIES OUTPUT_NAME test_trajectory PREFIX "")
target_link_libraries(${PROJECT_NAME}_test_trajectory
  ${catkin_LIBRARIES}
)

## TOOLS ------------------------------------------------------

# Tool for analyzing controller performance
add_library(controller_to_csv src/tools/controller_to_csv.cpp)
target_link_libraries(controller_to_csv
  ${catkin_LIBRARIES}
)
add_executable(${PROJECT_NAME}_controller_to_csv_main src/tools/controller_to_csv_main.cpp)
set_target_properties(${PROJECT_NAME}_controller_to_csv_main PROPERTIES OUTPUT_NAME controller_to_csv_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_controller_to_csv_main
  controller_to_csv
  ${Gflags_LIBRARIES}
  ${catkin_LIBRARIES}
)

# Tool for analyzing controller performance
add_library(csv_to_controller src/tools/csv_to_controller.cpp)
target_link_libraries(csv_to_controller
  ${catkin_LIBRARIES}
)
add_executable(${PROJECT_NAME}_csv_to_controller_main src/tools/csv_to_controller_main.cpp)
set_target_properties(${PROJECT_NAME}_csv_to_controller_main PROPERTIES OUTPUT_NAME csv_to_controller_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_csv_to_controller_main
  csv_to_controller
  ${Gflags_LIBRARIES}
  ${catkin_LIBRARIES}
)

# Tool for controlling a robot from keyboard
add_executable(${PROJECT_NAME}_keyboard_teleop src/tools/keyboard_teleop.cpp)
set_target_properties(${PROJECT_NAME}_keyboard_teleop PROPERTIES OUTPUT_NAME keyboard_teleop PREFIX "")
target_link_libraries(${PROJECT_NAME}_keyboard_teleop
  ${catkin_LIBRARIES}
)

add_subdirectory(rrbot_control)

## Install ------------------------------------------------------------

# Install libraries
install(TARGETS
    generic_hw_control_loop
    generic_hw_interface
    sim_hw_interface
    controller_to_csv
    csv_to_controller
  LIBRARY DESTINATION
    ${CATKIN_PACKAGE_LIB_DESTINATION}
)

# Install executables
install(TARGETS
    ${PROJECT_NAME}_sim_hw_main
    ${PROJECT_NAME}_test_trajectory
    ${PROJECT_NAME}_controller_to_csv_main
    ${PROJECT_NAME}_csv_to_controller_main
    ${PROJECT_NAME}_keyboard_teleop
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install header files
install(DIRECTORY include/${PROJECT_NAME}/   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

=== debian/changelog ===
ros-lunar-ros-control-boilerplate (0.4.1-0xenial) xenial; urgency=high

  * Changed boost::shared_ptr to typedef for Lunar support
  * Implemented simulated velocity control
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 19 Jun 2017 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.4.0-0xenial) xenial; urgency=high

  * Depend on Eigen3
  * Remove dependency on meta package
  * Fixed var name
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 28 Jun 2016 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.3.1-0xenial) xenial; urgency=high

  * API deprecation fix for rosparam_shortcuts
  * Switched to better use of rosparam_shortcuts
  * Ability to record all controller status data, not just at certain frequency
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 12 Jan 2016 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.3.0-0xenial) xenial; urgency=high

  * Removed bad reference name
  * Switched to using name_
  * Record error data
  * Disable soft joint limits
  * header to debug output
  * Added error checking of control loops time
  * Fix init() bug
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Sat, 26 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.2.1-0xenial) xenial; urgency=high

  * Merge branch 'indigo-devel' of github.com:davetcoleman/ros_control_boilerplate into indigo-devel
  * Fix install path
  * Improve user output message
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 08 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.2.0-0xenial) xenial; urgency=high

  * Do not automatically call init()
  * Removed warning of joint limits for continous joints
  * Fix missing variable
  * Improved rrbot_control example package
  * Moved rrbot example code into subdirectory
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 08 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.1.4-0xenial) xenial; urgency=high

  * Added missing dependency on sensor_msgs
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Sun, 06 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.1.3-0xenial) xenial; urgency=high

  * Fix catkin lint errors
  * Added FindGflags directly to this repo
  * Minor fix
  * Updated README
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Fri, 04 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.1.2-0xenial) xenial; urgency=high

  * Added dependency on gflags
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 01 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.1.1-0xenial) xenial; urgency=high

  * Added travis support
  * Updated README
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 01 Dec 2015 21:00:00 -0000

ros-lunar-ros-control-boilerplate (0.1.0-0xenial) xenial; urgency=high

  * Initial release of ros_control_boilerplate
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 01 Dec 2015 21:00:00 -0000

=== debian/control ===
Source: ros-lunar-ros-control-boilerplate
Section: misc
Priority: extra
Maintainer: Dave Coleman <davetcoleman@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libgflags-dev, ros-lunar-actionlib, ros-lunar-catkin, ros-lunar-cmake-modules, ros-lunar-control-msgs, ros-lunar-control-toolbox, ros-lunar-controller-manager, ros-lunar-hardware-interface, ros-lunar-joint-limits-interface, ros-lunar-roscpp, ros-lunar-rosparam-shortcuts, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-trajectory-msgs, ros-lunar-transmission-interface, ros-lunar-urdf
Homepage: https://github.com/davetcoleman/ros_control_boilerplate
Standards-Version: 3.9.2

Package: ros-lunar-ros-control-boilerplate
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-actionlib, ros-lunar-control-msgs, ros-lunar-control-toolbox, ros-lunar-controller-manager, ros-lunar-hardware-interface, ros-lunar-joint-limits-interface, ros-lunar-roscpp, ros-lunar-rosparam-shortcuts, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-trajectory-msgs, ros-lunar-transmission-interface, ros-lunar-urdf
Description: Simple simulation interface and template for setting up a hardware interface for ros_control
